
// Copyright (c) 2010-2017 niXman (i dot nixman dog gmail dot com). All
// rights reserved.
//
// This file is part of YAS(https://github.com/niXman/yas) project.
//
// Distributed under the Boost Software License, Version 1.0. (See accompanying
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
//
//
// Boost Software License - Version 1.0 - August 17th, 2003
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
//
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

#ifndef _yas_test__enum_hpp__included_
#define _yas_test__enum_hpp__included_

/***************************************************************************/

enum enum_test_enum1 { _1_1, _1_2, _1_3, _1_4 };

enum class enum_test_enum2: char { _2_1, _2_2, _2_3, _2_4 };

template<typename archive_traits>
bool enum_test(const char* archive_type, const char* io_type) {
	typename archive_traits::oarchive oa1;
	archive_traits::ocreate(oa1, archive_type, io_type);
	oa1 & _1_2
		 & _1_4;

	enum_test_enum1 e11, e12;
	typename archive_traits::iarchive ia1;
	archive_traits::icreate(ia1, oa1, archive_type, io_type);

	ia1 & e11
		 & e12;
	if ( e11 != _1_2 || e12 != _1_4 ) {
		std::cout << "ENUM deserialization error! [1]" << std::endl;
		return false;
	}

	typename archive_traits::oarchive oa2;
	archive_traits::ocreate(oa2, archive_type, io_type);
	oa2 & enum_test_enum2::_2_1
		 & enum_test_enum2::_2_3;

	enum_test_enum2 e21, e22;
	typename archive_traits::iarchive ia2;
	archive_traits::icreate(ia2, oa2, archive_type, io_type);
	ia2 & e21
		 & e22;
	if ( e21 != enum_test_enum2::_2_1 || e22 != enum_test_enum2::_2_3) {
		std::cout << "ENUM deserialization error! [2]" << std::endl;
		return false;
	}

	return true;
}

/***************************************************************************/

#endif // _yas_test__enum_hpp__included_
